#lang racket

;;;; 3. cvičenie z predmetu 2-AIN-285 Symbolické programovanie a LISP
;;;;
;;;; Meno a priezvisko:
;;;; Verzia DrRacket: 6.10.1
;;;; Dátum: 5.3.2018
;;;; WWW: http://www.ii.fmph.uniba.sk/cl/view.php/courses/2-AIN-285-lisp/1718ls/?lang=sk 
;;;; Kontakt: Jan.Komara(at)fmph.uniba.sk 
;;;;
;;;; Úvodná poznámka. Toto cvičenie je venované týmto témam:
;;;; - karteziánsky súčin,
;;;; - základné operácie na zoznamoch,
;;;; - aplikácie zoznamov.
;;;; Zadanie sa skladá z týchto súborov: 
;;;; - Súbory ex*.rkt obsahujú úlohy, ktoré máte riešiť na tomto cvičení.
;;;;
;;;; Hodnotenie.
;;;; - Počet bodov za úlohy v tomto súbore: 0
;;;; - Počet bodov za prémiove úlohy v tomto súbore: 0
;;;; - Počet bodov za projektové úlohy v tomto súbore: 0 
;;;; Odovzdať do 11.3.2018 (nedeľa) do 12:00.

;; [Lisp]

(require racket/undefined)
(define ... undefined)
(define (query f m n) (for/list ([i (in-range m (+ n 1))]) (list i (f i))))

;; Zopakovanie.

(define (fib n)
  (cond [(= n 0) 0]
        [(= n 1) 1]
        [else (+ (fib (- n 1)) (fib (- n 2)))]))

;; Literatúra.
;; [1] Hal Abelson and Jerry Sussman and Julie Sussman.
;;     Structure and Interpretation of Computer Programs.
;;     MIT Press, second edition, 1996. 

;;; Kapitola. Aritmetizácia dátových štruktúr.

;;; Sekcia. Karteziánsky súčin.

;; Konštruktor dvojíc.

;; (cons 1 2)
;; (pair? (cons 1 2))
;; (not (pair? 1))

;; Projekcie.
;;   car cons(x,y) = x ∧ cdr cons(x,y) = y

;; (car (cons 1 2))
;; (cdr (cons 1 2))

;; Opakované použitie projekcií.

;; (caar (cons (cons 1 2) (cons 3 4)))
;; (cdar (cons (cons 1 2) (cons 3 4)))
;; (cadr (cons (cons 1 2) (cons 3 4)))
;; (cddr (cons (cons 1 2) (cons 3 4)))

;; Úloha. Definujte funkciu twofibs takú, že
;;   twofibs(n) = cons(fib(n),fib(n+1))
;; Definujte ju s pomocou operácií cons, car a cdr bez použitia fib.

(define (twofibs n) ...)

;; (query fib 0 10)
;; (query (λ (n) (car (twofibs n))) 0 10)
;; (query (λ (n) (list (fib n) (car (twofibs n)))) 0 10)

;; Alternatívna implementácia pomocou špeciálnych foriem values a let-values.

(define (twofibs2 n)
  (if (= n 0)
      (values 0 1)
      (let-values ([(p1 p2) (twofibs2 (- n 1))])
        (values p2 (+ p2 p1)))))

;; (query fib 0 10)
;; (query (λ (n) (let-values ([(p1 p2) (twofibs2 n)]) p1)) 0 10)
;; (query (λ (n) (list (fib n) (let-values ([(p1 p2) (twofibs2 n)]) p1))) 0 10)
