#lang racket

;;;; 3. cvičenie z predmetu 2-AIN-285 Symbolické programovanie a LISP
;;;;
;;;; Meno a priezvisko:
;;;; Verzia DrRacket: 6.10.1
;;;; Dátum: 5.3.2018
;;;; WWW: http://www.ii.fmph.uniba.sk/cl/view.php/courses/2-AIN-285-lisp/1718ls/?lang=sk 
;;;; Kontakt: Jan.Komara(at)fmph.uniba.sk 
;;;;
;;;; Úvodná poznámka. Toto cvičenie je venované týmto témam:
;;;; - karteziánsky súčin,
;;;; - základné operácie na zoznamoch,
;;;; - aplikácie zoznamov.
;;;; Zadanie sa skladá z týchto súborov: 
;;;; - Súbory ex*.rkt obsahujú úlohy, ktoré máte riešiť na tomto cvičení.
;;;;
;;;; Hodnotenie.
;;;; - Počet bodov za úlohy v tomto súbore: 1
;;;; - Počet bodov za prémiove úlohy v tomto súbore: 0
;;;; - Počet bodov za projektové úlohy v tomto súbore: 0 
;;;; Odovzdať do 11.3.2018 (nedeľa) do 12:00.

;; [Lisp]

(require racket/undefined)
(define ... undefined)
(define (query f m n) (for/list ([i (in-range m (+ n 1))]) (list i (f i))))

;; Literatúra.
;; [1] Hal Abelson and Jerry Sussman and Julie Sussman.
;;     Structure and Interpretation of Computer Programs.
;;     MIT Press, second edition, 1996. 

;; (define nil null)

;;; Kapitola. Zoznamy.

;;; Sekcia. Zoznamy.

;; Príklad. Nasledujúci komponent obsahuje definíciu zoznamu, ktorý sa skladá
;; z prvých štyroch prvočísel.

(define small-primes (cons 2 (cons 3 (cons 5 (cons 7 null)))))

;; small-primes

;; Alternatívna definicia pomocou špeciálnej formy list.

(define small-primes2 (list 2 3 5 7))

;; small-primes2

;; Poznámka. Predikát null? testuje, či vstup je prázdny zoznam.

;; (null? null)
;; (null? (list))
;; (not (null? (cons 1 null)))
;; (not (null? small-primes))

;; Poznámka. Predikát list? testuje, či vstup je zoznam.

;; (list? null)
;; (list? (list))
;; (list? (cons 1 null))
;; (list? small-primes)
;; (not (list? 1))
;; (not (list? (cons 1 2)))

;;; Sekcia. Základné operácie na zoznamoch.

;; Príklad. Nasledujúci komponent obsahuje program, ktorý počíta dĺžku zoznamu.

(define (length xs)
  (if (null? xs) 0 (+ (length (cdr xs)) 1)))

;; (length (list 1 2 3 4 5))

;; Alternatívna implementácia s pomocou predikátu pair?.

(define (length2 xs)
  (if (pair? xs) (+ (length2 (cdr xs)) 1) 0))

;; (length2 (list 1 2 3 4 5))

;; Úloha. Zostrojte program, ktorý počíta indexovaciu funkciu na zoznamoch.
;; Indexuje sa od nuly.
;;   M-syntax: xs[i].

(define (list-ref xs i) ...)

;; (list-ref (list 10 11 12 13 14) 0)
;; (query (λ (i) (list-ref (list 10 11 12 13 14) i)) 0 4)

;; Úloha. Zostrojte program, ktorý zreťazí dva zoznamy.

(define (append xs ys) ...)

;; (append (list 1 2) (list 3 4 5))

;; Úloha. Zostrojte program, ktorý overuje príslušnosť prvku v zozname.

(define (member? x xs) ...)

;; (member? 3 (list 1 2 3 4 5))
;; (not (member? 33 (list 1 2 3 4 5)))

;; (1 bod)
;; Úloha. Nájdite iteratívnu implementáciu operácie, ktorá obracia poradie
;; prvkov v zozname.

(define (reverse xs) ...)

;; (reverse (list 1 2 3 4 5))

;;; Sekcia. Funkcionálne programovanie.

;; Úloha. Zostrojte pomocou λ program, ktorý vytvorí jednoprvkový zoznam
;; obsahujúci vstupný prvok.

(define singleton ...)

;; (singleton 1)

;; Úloha. Zostrojte program pre funkcionál map(f,xs), ktorý aplikuje funkciu f
;; na každý prvok zoznamu xs:
;;   length map(f,xs) = length(xs)
;;   i < length(xs) → map(f,xs)[i] = f(xs[i])

(define (map f xs) ...)

;; (map (λ (x) (* x x)) (list 1 2 3 4 5))

;; Úloha. Zostrojte program pre funkcionál each?(p?,xs), ktorý overí, či každý
;; prvok zoznamu xs má vlastnosť p?.

(define (each? p? xs) ...)

;; (each? (λ (x) (= (remainder x 2) 0)) (list 0 2 4 6 8))
;; (not (each? (λ (x) (= (remainder x 2) 0)) (list 0 2 4 7 8)))

;; Úloha. Zostrojte program pre funkcionál some?(p?,xs), ktorý overí, či
;; existuje prvok zoznamu xs s vlastnosťou p?.

(define (some? p? xs) ...)

;; (not (some? (λ (x) (= (remainder x 2) 1)) (list 0 2 4 6 8)))
;; (some? (λ (x) (= (remainder x 2) 1)) (list 0 2 4 7 8))
