#lang racket

;;;; 3. cvičenie z predmetu 2-AIN-285 Symbolické programovanie a LISP
;;;;
;;;; Meno a priezvisko:
;;;; Verzia DrRacket: 6.10.1
;;;; Dátum: 5.3.2018
;;;; WWW: http://www.ii.fmph.uniba.sk/cl/view.php/courses/2-AIN-285-lisp/1718ls/?lang=sk 
;;;; Kontakt: Jan.Komara(at)fmph.uniba.sk 
;;;;
;;;; Úvodná poznámka. Toto cvičenie je venované týmto témam:
;;;; - karteziánsky súčin,
;;;; - základné operácie na zoznamoch,
;;;; - aplikácie zoznamov.
;;;; Zadanie sa skladá z týchto súborov: 
;;;; - Súbory ex*.rkt obsahujú úlohy, ktoré máte riešiť na tomto cvičení.
;;;;
;;;; Hodnotenie.
;;;; - Počet bodov za úlohy v tomto súbore: 1
;;;; - Počet bodov za prémiove úlohy v tomto súbore: 2
;;;; - Počet bodov za projektové úlohy v tomto súbore: 3
;;;; Odovzdať do 11.3.2018 (nedeľa) do 12:00.

;; [Lisp]

(require racket/undefined)
(define ... undefined)
(define (query f m n) (for/list ([i (in-range m (+ n 1))]) (list i (f i))))

;; Literatúra.
;; [1] Hal Abelson and Jerry Sussman and Julie Sussman.
;;     Structure and Interpretation of Computer Programs.
;;     MIT Press, second edition, 1996. 

;; (define nil null)

;;; Kapitola. Zoznamy.

;;; Sekcia. Konečné množiny ako usporiadané zoznamy.

;; Úloha. Zostrojte program, ktorý overí, či daný zoznam reprezentuje konečnú
;; množinu.

(define (set? set) ...)

;; (set? null)
;; (set? (list 1))
;; (set? (list 1 2 3))
;; (not (set? (list 1 3 2)))
;; (not (set? (list 1 1 3)))

;; Úloha. Zostrojte program, ktorý testuje príslušnosť prvku v množine.

(define (member? x set) ...)

;; (not (member? 5 null))
;; (member? 5 (list 5))
;; (member? 5 (list 1 2 5 6))
;; (not (member? 5 (list 1 2 6 7)))

;; Úloha. Zostrojte program, ktorý vloží prvok do množiny.

(define (insert x set) ...)

;; (insert 5 null)
;; (insert 5 (list 1 2 3 4 6 7))
;; (insert 5 (list 1 2 3 4 5 6 7))

;; (1 bod)
;; Úloha. Zostrojte program, ktorý vyberie prvok z množiny.

(define (delete x set) ...)

;; (delete 5 null)
;; (delete 5 (list 1 2 3 4 5 6 7))
;; (delete 5 (list 1 2 3 4 6 7))

;;; Sekcia. Triedenie zoznamov.

;; (prémia 2 body)
;; Úloha. Implementujte triedenie zlučovaním (merge sort).

(define (merge-sort xs) ...)

;; (merge-sort (list 2 5 3 8 7 1 6 4))

;;; Sekcia. Kombinatorika na zoznamoch.

;; Poznámka. Permutáciou zoznamu rozumieme taký zoznam, ktorý sa líši od toho
;; pôvodného len poradím prvkov.

;; (projekt 3 body)
;; Úloha. Implementujte program, ktorý vráti všetky permutácie daného zoznamu.
;; Výsledok reprezentujte ako zoznam zoznamov.

(define (permutations xs) ...)

;; (permutations null)
;; (permutations (list 1))
;; (permutations (list 1 2))
;; (permutations (list 1 2 3))
;; (permutations (list 1 2 3 4))

